/*
 * Copyright (C) 2005, 2006 Masahito Henmi, All rights reserved.
 */
package strawberry.renderkit;
//package dwarf.jsf.renderkit;

import java.io.Serializable;
import java.text.ParseException;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;
import javax.faces.convert.ConverterException;
import javax.faces.application.FacesMessage;
/**
 *  NĂNX̂Amyfaces̒Ɏ悤
 *  ̂ŁAQlɂĂB
 */
public class DateData implements Serializable {

  static final long serialVersionUID = -835420431554223807L;

  private String day;
  private String month;
  private String year;
  private String hours;
  private String minutes;
  private String seconds;

  public String toString() {
    return getClass().getName() + "[" + year + "/" + month + "/" + day + " " + hours + ":" + minutes + ":" + seconds + "]";
  }

  
  public DateData() {
  }


  public void setDate(String str) {
    String[] arr = str.split("-");

    if (arr.length >= 1) year = arr[0];
    if (arr.length >= 2) month = arr[1];
    if (arr.length >= 3) day = arr[2];
  }

  public void setTime(String str) {

    String[] arr = str.split(":");

    if (arr.length >= 1) hours = arr[0];
    if (arr.length >= 2) minutes = arr[1];
    if (arr.length >= 3) seconds = arr[2];
  }

  public DateData(Date date, Locale currentLocale, String _timeZone, boolean uses_ampm) {
    if( date == null )
      date = new Date();

    Calendar calendar = Calendar.getInstance(currentLocale);
    
    calendar.setTime( date );
    day = Integer.toString(calendar.get(Calendar.DAY_OF_MONTH));
    month = Integer.toString(calendar.get(Calendar.MONTH)+1);
    year = Integer.toString(calendar.get(Calendar.YEAR));
    if (uses_ampm) {
      int int_hours = calendar.get(Calendar.HOUR);
      // ampm hours must be in range 0-11 to be handled right; we have to handle "12" specially
      if (int_hours == 0) {
        int_hours = 12;
      }
    } else {
    }
  }
    
  public java.sql.Date parseDate() throws ParseException{
    if (day == null || month == null || year == null)
        return null;
    // add
    if (day.length() == 0 && month.length() == 0 && year.length() == 0)
      return null;

    if ("unselected".equals(day) || "unselected".equals(month) ||
        "unselected".equals(year) )
        return null;
    
    return java.sql.Date.valueOf(year + "-" + month + "-" + day);
  }

  public java.sql.Time parseTime() throws ParseException {

    if (seconds == null || minutes == null || hours == null)
        return null;
    // add
    if (seconds.length() == 0 && minutes.length() == 0 && hours.length() == 0)
      return null;

    if ("unselected".equals(seconds) || "unselected".equals(minutes) ||
        "unselected".equals(hours) )
        return null;

    if (hours.matches("[0-9]*") == false || minutes.matches("[0-9]*") == false ||
        seconds.matches("[0-9]*") == false) {
      throw new ConverterException( new FacesMessage("Ԃ͂Ă܂") );
    }

    int iHours = Integer.parseInt(hours);
    int iMinutes = Integer.parseInt(minutes);
    int iSeconds = Integer.parseInt(seconds);

    if (iHours < 0 || 24 <= iHours || iMinutes < 0 || 60 <= iMinutes ||
        iSeconds < 0 || 60 <= iSeconds) {
      throw new ConverterException( new FacesMessage("Ԃ͂Ă܂") );
    }
    
    return java.sql.Time.valueOf(hours + ":" + minutes + ":" + seconds);
  }

  public java.sql.Timestamp parseTimestamp() throws ParseException {

    if (seconds == null || minutes == null || hours == null)
        return null;
    // add
    if (seconds.length() == 0 && minutes.length() == 0 && hours.length() == 0)
      return null;

    if ("unselected".equals(seconds) || "unselected".equals(minutes) ||
        "unselected".equals(hours) )
        return null;

    if (hours.matches("[0-9]*") == false || minutes.matches("[0-9]*") == false ||
        seconds.matches("[0-9]*") == false) {
      throw new ConverterException( new FacesMessage("Ԃ͂Ă܂") );
    }

    int iHours = Integer.parseInt(hours);
    int iMinutes = Integer.parseInt(minutes);
    int iSeconds = Integer.parseInt(seconds);

    if (iHours < 0 || 24 <= iHours || iMinutes < 0 || 60 <= iMinutes ||
        iSeconds < 0 || 60 <= iSeconds) {
      throw new ConverterException( new FacesMessage("Ԃ͂Ă܂") );
    }
    
    return java.sql.Timestamp.valueOf(year + "-" + month + "-" + day + " " +
      hours + ":" + minutes + ":" + seconds);
  }

  
  public String getDay() {
    return day;
  }
  public void setDay(String day) {
    this.day = day;
  }

  public String getMonth() {
    return month;
  }
  public void setMonth(String month) {
    this.month = month;
  }

  public String getYear() {
    return year;
  }
  public void setYear(String year) {
    this.year = year;
  }

  public String getHours() {
    return ( hours );
  }
  public void setHours(String hours) {
    this.hours = hours;
  }
  public String getMinutes() {
    return ( minutes );
  }
  public void setMinutes(String minutes) {
    this.minutes = minutes;
  }

  public String getSeconds() {
    return ( seconds );
  }
  public void setSeconds(String seconds) {
    this.seconds = seconds;
  }

}
