/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package strawberry.webapp;

import strawberry.*;

import java.io.IOException;
import java.util.logging.*;
import javax.servlet.*;
import javax.servlet.http.*;
import strawberry.ctx.ExternalContextImpl2;
import strawberry.application.ApplicationAssociate;
import strawberry.wrapper.ExternalContextJar;
import strawberry.wrapper.Tomcat3HttpServletRequest;
/**
 *
 */
public class FacesletServlet extends HttpServlet {
  
  // jdk1.4 logging
  protected final static Logger log = Logger.getLogger("strawberry.FacesletServlet");

  FaceletsBridge invoker = null;

  /**
   *  FaceletsBridge ̃CX^X𓾂
   */
  private FaceletsBridge getInvokerIF() {
    if (invoker == null) {
      try {
        invoker = new FaceletsBridgeVer8();
      } catch (Exception ex) {
        log.log(Level.SEVERE, "(30) " + ex.getMessage(), ex);
      }
    }
    return invoker;
  }

  boolean filter = true;
  
  protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

    String pathInfo = request.getPathInfo();
    if (pathInfo != null) {
      pathInfo = pathInfo.toUpperCase();
      if (pathInfo.startsWith("/WEB-INF/")
          || pathInfo.equals("/WEB-INF")
          || pathInfo.startsWith("/META-INF/")
          || pathInfo.equals("/META-INF")) {
        response.sendError(HttpServletResponse.SC_NOT_FOUND);
        return ;
      }
    }

    ServletContext sc = getServletContext();
    log.info("59) service start ==========================");

    HttpServletRequest decorate = request;

    if (filter) {
      decorate = new Tomcat3HttpServletRequest((HttpServletRequest) request);
    }
    
    ExternalContextImpl2 outer = new ExternalContextImpl2(sc, decorate, response); // Wi

    ExternalContextJar ec = new ExternalContextJar(outer);

    
    FaceletsBridge bridge = getInvokerIF();

    // tomcat3 œ΍  (web.xml̐ݒQ)
    if (sc.getAttribute("STRAWBERRY_OBJECT") == null)
      sc.setAttribute("STRAWBERRY_OBJECT", rc);
    
    if (sc.getAttribute(ApplicationAssociate.ASSOCIATE_KEY) == null)
      bridge.initialize(sc, rc);

    bridge.doLifecycle(ec, rc);
  
    log.info("77) service end ============================");
  }
  

  
  SimpleResourceConfig rc = new SimpleResourceConfig();
  
}
